package ru.volgait.task12;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

/**
 * Created by Mikhail Tarapata on 29.04.2017.
 */
public class BinaryTreeUtilsTest {

    Node<Integer> tree;

    @Before
    public void init() {
        tree = new Node<>();
        tree.value = 1;

        Node<Integer> n1 = new Node<>();
        n1.value = 2;
        Node<Integer> n2 = new Node<>();
        n2.value = 3;
        Node<Integer> n3 = new Node<>();
        n3.value = 4;
        n1.left = n2;
        n2.left = n3;
        tree.left = n1;
    }

    @Test
    public void node() throws Exception {
        Node<Integer> result = BinaryTreeUtils.node(tree, 1);
        assertEquals(tree, result);

        result = BinaryTreeUtils.node(tree, 11);
        assertNull(result);
    }

    @Test
    public void contains() throws Exception {
        boolean contains = BinaryTreeUtils.contains(tree, 4);
        assertTrue(contains);

        Node<Integer> clone = BinaryTreeUtils.clone(tree);
        contains = BinaryTreeUtils.contains(tree, 4);
        assertTrue(contains);
    }

    @Test
    public void depth() throws Exception {
        int depth = BinaryTreeUtils.depth(tree);
        assertEquals(4, depth);
    }
}