package ru.volgait.task4;

import org.junit.Test;

import java.lang.reflect.InvocationTargetException;

/**
 * Created by Mikhail Tarapata on 29.04.2017.
 */

public class JsonSerializerImplTest {

    JsonSerializer json = new JsonSerializerImpl();

    @Test
    public void testSerialize() throws Exception {
        TestObject test = new TestObject(1, "test", 0.0321);
        NestedObject obj = new NestedObject();
        obj.setNumber(999);
        test.setObj(obj);
        Integer[] arr = new Integer[] {1, 2, 3};
        test.setArr(arr);
        System.out.print(json.serialize(test));
    }

    @Test (expected = IllegalArgumentException.class)
    public void testIncorrectArgument() throws InvocationTargetException, IllegalAccessException {
        json.serialize(null);
    }
}