package ru.volgait.task3;

import org.junit.Test;

import java.io.*;
import java.nio.charset.StandardCharsets;

import static org.junit.Assert.*;

/**
 * Created by Mikhail Tarapata on 29.04.2017.
 */
public class CompresserImplTest {

    @Test
    public void compresserTest() throws IOException {
        CompressorImpl c = new CompressorImpl();
        InputStream input = new ByteArrayInputStream("AAAAABBAAAAAAAAAACCCCC".getBytes(StandardCharsets.UTF_8));
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        c.compress(input, out);

        byte[] byteArray = out.toByteArray();
        assertEquals("5A2B10A5C", new String(byteArray));
    }
}